
{ extract data from .GCF files (CHEAT VIERER Version 1.1 files) }


{$M, 8192,0,655355}

USES Dos,
     Objects,
     GUtils;

CONST
  SLineSize = 20;

TYPE
  PCheat      = ^TCheat;
  TCheat      = OBJECT(TObject)
     Name     : PString;
     Line     : LongInt;
     LNum     : Word;
     CONSTRUCTOR Init(aName: STRING; aLine: LongInt; aLNum: Word);
     DESTRUCTOR Done; VIRTUAL;
  END;

VAR
  Database: PCollection;
  FileName: STRING;
  MaxLines: LongInt;

CONSTRUCTOR TCheat.Init(aName: STRING; aLine: LongInt; aLNum: Word);
BEGIN
  Name := NewStr(aName);
  Line := aLine;
  LNum := aLNum;
END;

DESTRUCTOR TCheat.Done;
BEGIN
  DisposeStr(Name);
END;

FUNCTION Code(St: STRING): STRING;
VAR I: Byte;
  FUNCTION RetRes: Byte; NEAR;
  VAR A: Byte;
  BEGIN
    A := 1;
    IF Odd(I) THEN Inc(A);
    RetRes := A;
  END;
BEGIN
  FOR I := 1 TO Length(St) DO
    St[I] := Chr( Ord(St[I]) XOR (Ord(St[0])+150+RetRes));
  Code := St;
END;

PROCEDURE ReadDatabase;
VAR
  CVFile: Text;
  CVData: STRING;
  S1,S2 : STRING;
  I1,I2 : Integer;
  I     : Byte;

BEGIN
  Assign(CVFile,FileName);
  {$I-}
    Reset(CVFile);
  {$I+}
  IF IOResult <> 0 THEN
  BEGIN
    Writeln('Error opening '+FileName);
    Halt(2);
  END;
  Readln(CVFile,CVData);
  IF CVData <> 'CHEAT VIEWER FILE' THEN
  BEGIN
    Writeln(FileName+' is not CHEAT VIEWER file');
    Close(CVFile);
    Halt(3);
  END;
  Database := New(PCollection, Init(1,1));
  REPEAT
    Readln(CVFile,CVData);
    CVData := Code(CVData);
    IF CVData = '-=This is the end=-' THEN Break;
    S1     := ExtractWords(1,1,CVData);
    S2     := ExtractWords(3,1,CVData);
    CVData := ExtractWords(2,1,CVData);
    I1     := StrToInt(S1);
    I2     := StrToInt(S2);
    IF I1+I2 > MaxLines THEN MaxLines := I1+I2;
    FOR I := 1 TO Length(CVData) DO
      IF CVData[I] = '^' THEN CVData[I] := ' ';
    Database^.Insert(New(PCheat,Init(CVData,I1,I2)));
  UNTIL True = False;
  Close(CVFile);
END;

PROCEDURE SaveCheat(FName: STRING; Position: Integer);
VAR F,F2: Text; I,R: Word; Cheat: PCheat; S: STRING;
BEGIN
  Assign(F,FileName); Reset(F);

  Cheat := Database^.At(Position-1);

  Assign(F2,FName); Rewrite(F2); Writeln(F2,Cheat^.Name^,#13#10);

  FOR I := 1 TO Database^.Count+2 DO Readln(F);
  FOR I := 1 TO Cheat^.Line-1 DO Readln(F);

  FOR I := 1 TO Cheat^.LNum DO
  BEGIN
    Readln(F,S);
    S := Code(S);
    IF Pos(#9,S) <> 0 THEN
    REPEAT
      Insert(Replicate(8,' '),S, LastPos(#9,S));
      IF LastPos(#9,S) <> 0 THEN Delete(S,LastPos(#9,S),1);
    UNTIL LastPos(#9,S) = 0;
    Writeln(F2,S);
    IF Eof(F) THEN Break;
  END;
  Close(F);
  Close(F2);
END;

VAR I: Integer;

BEGIN
  FileName := 'NORMAL.GCF';
  ReadDatabase;
  FOR I := 105 TO Database^.Count + 105 DO
  BEGIN
    write('');
    SaveCheat(IntToStr(I),I-104);
  END;
  Writeln;
  Dispose(Database, Done);
END.